// IPswapDlg.cpp : implementation file
//

#include "stdafx.h"
#include "IPswap.h"
#include "IPswapDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#define MAXPATH  255
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();
	
// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIPswapDlg dialog

CIPswapDlg::CIPswapDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CIPswapDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CIPswapDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CIPswapDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CIPswapDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CIPswapDlg, CDialog)
	//{{AFX_MSG_MAP(CIPswapDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_LBN_DBLCLK(IDC_IPADDLST, OnDblclkIpaddlst)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIPswapDlg message handlers

BOOL CIPswapDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	IPList=(CListBox*)GetDlgItem(IDC_IPADDLST);
	///////////////////////////////////
	HKEY AppKey = NULL;
	LONG lRet1 =	RegOpenKeyEx( HKEY_LOCAL_MACHINE,"SYSTEM\\CurrentControlSet\\Services\\NetBT\\Linkage",0,KEY_EXECUTE|KEY_READ|KEY_ALL_ACCESS,&AppKey);
	DWORD dwS=MAXPATH;
	unsigned char szPath[MAXPATH];
	if(RegQueryValueEx(AppKey,"Bind",NULL,NULL,szPath,&dwS))
	{
		AfxMessageBox("Error Accessing Registry");
	}
	NetAdapt=(CString)szPath;
	NetAdapt.MakeReverse();
	int slash=NetAdapt.Find("\\",0);
	NetAdapt=NetAdapt.Left(slash);
	NetAdapt.MakeReverse();
	//MessageBox(NetAdapt);
	
	////////////////////////////
		IPList->ResetContent();
	HKEY AppPathKey = NULL;
	//LONG lRet =	RegOpenKeyEx( HKEY_LOCAL_MACHINE,"SYSTEM\\CurrentControlSet\\Services\\RTL81391\\Parameters\\Tcpip",0,KEY_EXECUTE|KEY_READ|KEY_ALL_ACCESS,&AppPathKey);
	LONG lRet =	RegOpenKeyEx( HKEY_LOCAL_MACHINE,"SYSTEM\\CurrentControlSet\\Services\\"+NetAdapt+"\\Parameters\\Tcpip",0,KEY_EXECUTE|KEY_READ|KEY_ALL_ACCESS,&AppPathKey);
/*	if(lRet==ERROR_SUCCESS)
		MessageBox("Key is opened");
	else
		MessageBox("Key is closed");*/
	DWORD dwSize = MAXPATH;
	DWORD dwSize1 = MAXPATH;
	unsigned char szAppPath[MAXPATH];
	unsigned char szAppPath1[MAXPATH];
	CString FullIP,SubnetMask;
	if(RegQueryValueEx(AppPathKey,"IpAddress",NULL,NULL,szAppPath,&dwSize)!= ERROR_SUCCESS )
	{
		AfxMessageBox("Error while Accessing registry");
		return 0;
	}
	else{

		//ssageBox((CString)szAppPath);
			//MessageBox((CString)szAppPath[28]);
			//FullIP=(CString)szAppPath;
		for(int i=0;i<255;i++)
			if((CString)szAppPath[i]!="")
			FullIP=FullIP+(CString)szAppPath[i];
			else
			{
				if(FullIP.GetLength()>=8)
				{
				IPList->AddString(FullIP);				
				iparray.Add(FullIP);
				}
				
				FullIP="";
			}
			
	}

	if(RegQueryValueEx(AppPathKey,"SubnetMask",NULL,NULL,szAppPath1,&dwSize1)!= ERROR_SUCCESS )
	{
		AfxMessageBox("Error while Accessing registry");
		return 0;
	}
	else{

		for(int i=0;i<255;i++)
			if((CString)szAppPath1[i]!="")
			SubnetMask=SubnetMask+(CString)szAppPath1[i];
			else
			{
				if(SubnetMask.GetLength()>=8)
				{
				subnetarray.Add(SubnetMask);				
				}
				
				SubnetMask="";
			}
			
	}	



	RegCloseKey(AppPathKey);


	///////////////////////////
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CIPswapDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CIPswapDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CIPswapDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CIPswapDlg::OnDblclkIpaddlst() 
{
	CString teststr,teststr1;	
	CString iptobemoved=iparray.GetAt(0);
	CString subnettobemoved=subnetarray.GetAt(0);

	int curr=IPList->GetCurSel();
	if(curr==0) return;
	teststr=iparray.GetAt(curr);
	teststr1=subnetarray.GetAt(curr);

	iparray.SetAt(curr,iptobemoved);	
	iparray.SetAt(0,teststr);	
	subnetarray.SetAt(curr,subnettobemoved);
	subnetarray.SetAt(0,teststr1);

	IPList->ResetContent();	

	HKEY AppPathKey = NULL;
	LONG lRet =	RegOpenKeyEx( HKEY_LOCAL_MACHINE,"SYSTEM\\CurrentControlSet\\Services\\"+NetAdapt+"\\Parameters\\Tcpip",0,KEY_EXECUTE|KEY_READ|KEY_ALL_ACCESS,&AppPathKey);

	DWORD dwSize = MAXPATH;
	unsigned char szAppPath[MAXPATH];
	CString FullIP;
	if(RegQueryValueEx(AppPathKey,"IpAddress",NULL,NULL,szAppPath,&dwSize)!= ERROR_SUCCESS )
	{
		AfxMessageBox("Error while Accessing registry");
		return;
	}
	int z=0;
	unsigned char ii[100];
	unsigned char subne[100];
	CString ip,sn;

	for(int p=0;p<=iparray.GetSize()-1;p++)
	{
		ip=iparray.GetAt(p);
		for(int k=0;k<=ip.GetLength()-1;k++)
		{
			ii[z]=ip.GetAt(k);
			z=z+1;
		}
		ii[z]='\0';
		z++;
	}
	int x=0;
	for(int q=0;q<=subnetarray.GetSize()-1;q++)
	{
		sn=subnetarray.GetAt(q);
		for(int k=0;k<=sn.GetLength()-1;k++)
		{
			subne[x]=sn.GetAt(k);
			x=x+1;
		}
		subne[x]='\0';
		x++;
	}

	

	RegSetValueEx(AppPathKey,"IpAddress",0,REG_MULTI_SZ,ii,z);
	RegSetValueEx(AppPathKey,"SubnetMask",0,REG_MULTI_SZ,subne,x);
	RegCloseKey(AppPathKey);
	for(int j=0;j<=iparray.GetSize()-1;j++)
	{
		IPList->AddString(iparray.GetAt(j));
	}

		MessageBox("Successfully swaped");
}
